.. _upgrade_cc:

*******
Upgrade
*******

Upgrading a *XiVO CC* is done by executing commands through a terminal on the
server.

.. note:: Downgrade is not supported

Overview
========

The upgrade consists of the following steps:

* switch the version via ``xivo-dist`` utility
* upgrade via the ``xivocc-upgrade`` utility: it will upgrade the system (Debian packages) and the XiVOCC containers

.. warning:: This upgrade procedure applies only to XiVO CC installed via the ``xivocc-installer`` package.

Preparing the upgrade
=====================

There are two cases:

#. :ref:`Upgrade to another LTS XiVO CC version <upgrade_to_lts_version_xcc>`,
#. :ref:`Upgrade to the latest Bugfix release <upgrade_latest_ltsbugfixrel_xcc>` of your current installed LTS version.


.. _upgrade_to_lts_version_xcc:

Upgrade to another LTS version
------------------------------

To upgrade to another XiVO Solution **LTS**:

#. Switch the sources to the new XiVO CC **LTS** version with ``xivo-dist``, for example, to switch to Gaia LTS version::

    xivo-dist xivo-gaia
#. **Read carefully the** :ref:`xivosolutions_release` starting from your current version to the version you target (read **even more
   carefully** the New features and Behavior changes between LTS)
#. **Check** the specific instructions and manual steps *from your current LTS to your targetted LTS* and all intermediate LTS: see :ref:`Manual steps for LTS upgrade <upgrade_lts_manual_steps>`
#. **Check also** if you are in a specific setup that requires a :ref:`specific procedure <upgrade_specific_proc_xcc>`
#. And then upgrade, see `Upgrading`_


.. _upgrade_latest_ltsbugfixrel_xcc:

Upgrade to latest Bugfix release of an LTS version
--------------------------------------------------

.. important:: For version older than Five (2017.03), see `XiVO Five documentation <https://documentation.xivo.solutions/projects/five>`_

After the release of a *version* (e.g. *Freya (2020.18)*) we may backport some bugfixes in this version.
We will then create a **subversion** (e.g. Freya **.04** (2020.18 **.04**)) shipping these bugfixes.
These bugfix version does not contain any behavior change.

To upgrade to the **latest subversion** of your current installed *version* you need to:

#. **Read carefully the** :ref:`xivosolutions_release` starting from your installed version (e.g. Freya.00) to the latest bugfix release (e.g. Freya.04).
#. Verify that the debian sources list corresponds to your *installed LTS* or refix it, for example for Freya::

    xivo-dist xivo-freya
#. Verify that the :file:`/etc/docker/compose/factory.env` file has

   * ``XIVOCC_TAG=VERSION`` (where ``VERSION`` is your current installed *version* - e.g. *2020.18*)
   * and ``XIVOCC_DIST=latest``
#. And then upgrade, see `Upgrading`_



Upgrading
=========

.. note:: About `xivocc-upgrade` script usage see :ref:`xivocc-upgrade_script`

After having prepared your upgrade (see above), you can upgrade:

#. When ready, launch the upgrade process. **All CC services will be stopped during the process**::

    xivocc-upgrade



Post Upgrade
============

When finished:

* Check your upgrade through :ref:`check-list`.
* Check that all the services are in the correct version. Compare the output of ``xivocc-dcomp version`` with the table in :ref:`xivosolutions_release`


Manual steps for LTS upgrade
============================

See :ref:`Manual steps for LTS upgrade <upgrade_lts_manual_steps>` in XiVO Upgrade page.


.. _upgrade_specific_proc_xcc:

Specific procedures
===================

.. toctree::
   :maxdepth: 2

   xivocc_old_pack_reporting_upgrade
   xivocc_upgrade_to_debian_9_stretch


Upgrade notes
=============

See :ref:`xivosolutions_release` for version specific informations.


